"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMappedFilters = exports.ExpressRouterIntegrationErrors = void 0;
var express_1 = __importDefault(require("express"));
var routes_1 = require("../routes");
var modules_1 = require("./../modules");
var enums_1 = require("../enums");
var ExpressRouterIntegrationErrors;
(function (ExpressRouterIntegrationErrors) {
    ExpressRouterIntegrationErrors["MISSING_LOCALE"] = "Please specify a locale in the body through: e.g. \"locale\": \"de_DE\" ";
    ExpressRouterIntegrationErrors["UNKNOWN_ROUTE"] = "Could not map given route and method.";
})(ExpressRouterIntegrationErrors = exports.ExpressRouterIntegrationErrors || (exports.ExpressRouterIntegrationErrors = {}));
function getExpressRouter(_a) {
    var _this = this;
    var api = _a.api;
    var router = express_1.default.Router();
    var logger = new modules_1.Logger(api.logLevel, 'Express-Server');
    router.use(express_1.default.json());
    router.post([routes_1.FETCH_ELEMENT_ROUTE, enums_1.FSXAProxyRoutes.FETCH_ELEMENT_ROUTE], function (req, res) { return __awaiter(_this, void 0, void 0, function () {
        var response, err_1;
        var _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    logger.info('Received POST on route: ', routes_1.FETCH_ELEMENT_ROUTE);
                    logger.debug('POST request body', req.body);
                    if (!req.body || req.body.locale == null) {
                        logger.error(routes_1.FETCH_ELEMENT_ROUTE, 'missing locale', req.body);
                        return [2 /*return*/, res.status(400).json({
                                error: ExpressRouterIntegrationErrors.MISSING_LOCALE,
                            })];
                    }
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, api.fetchElement({
                            id: req.body.id,
                            locale: req.body.locale,
                            additionalParams: (_a = req.body) === null || _a === void 0 ? void 0 : _a.additionalParams,
                            remoteProject: (_b = req.body) === null || _b === void 0 ? void 0 : _b.remote,
                            filterContext: (_c = req.body) === null || _c === void 0 ? void 0 : _c.filterContext,
                            normalized: (_d = req.body) === null || _d === void 0 ? void 0 : _d.normalized,
                        })];
                case 2:
                    response = _e.sent();
                    return [2 /*return*/, res.json(response)];
                case 3:
                    err_1 = _e.sent();
                    logger.error('could not fetch element: ', req, err_1.message);
                    //response object contains error and message properties for backwards compatibility
                    return [2 /*return*/, res
                            .status(err_1.statusCode)
                            .send({ message: err_1.message, error: err_1.message })];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    router.post([routes_1.FETCH_NAVIGATION_ROUTE, enums_1.FSXAProxyRoutes.FETCH_NAVIGATION_ROUTE], function (req, res) { return __awaiter(_this, void 0, void 0, function () {
        var response, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    logger.info('Received POST on route', routes_1.FETCH_NAVIGATION_ROUTE);
                    logger.debug('POST request body', req.body);
                    if (req.body.locale == null) {
                        logger.error(routes_1.FETCH_NAVIGATION_ROUTE, 'missing locale', req.body);
                        return [2 /*return*/, res.status(400).json({
                                error: ExpressRouterIntegrationErrors.MISSING_LOCALE,
                            })];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, api.fetchNavigation({
                            initialPath: req.body.initialPath || '/',
                            locale: req.body.locale,
                            filterContext: req.body.filterContext,
                        })];
                case 2:
                    response = _a.sent();
                    return [2 /*return*/, res.json(response)];
                case 3:
                    err_2 = _a.sent();
                    logger.error('was not able to fetch Navigation: ' + err_2.message);
                    //response object contains error and message properties for backwards compatibility
                    return [2 /*return*/, res
                            .status(err_2.statusCode)
                            .send({ message: err_2.message, error: err_2.message })];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    router.post([routes_1.FETCH_BY_FILTER_ROUTE, enums_1.FSXAProxyRoutes.FETCH_BY_FILTER_ROUTE], function (req, res) { return __awaiter(_this, void 0, void 0, function () {
        var response, err_3;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    logger.info('Received POST on route', routes_1.FETCH_BY_FILTER_ROUTE);
                    logger.debug('POST request body', req.body);
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, api.fetchByFilter({
                            filters: req.body.filters || [],
                            locale: req.body.locale,
                            page: req.body.page ? req.body.page : undefined,
                            pagesize: req.body.pagesize ? req.body.pagesize : undefined,
                            sort: req.body.sort ? req.body.sort : [],
                            additionalParams: req.body.additionalParams || {},
                            remoteProject: req.body.remote ? req.body.remote : undefined,
                            filterContext: req.body.filterContext,
                            normalized: (_a = req.body) === null || _a === void 0 ? void 0 : _a.normalized,
                        })];
                case 2:
                    response = _b.sent();
                    return [2 /*return*/, res.json(response)];
                case 3:
                    err_3 = _b.sent();
                    logger.error('was not able to fetch by filter: ', err_3.message);
                    console.log(err_3);
                    //response object contains error and message properties for backwards compatibility
                    return [2 /*return*/, res
                            .status(err_3.statusCode)
                            .send({ message: err_3.message, error: err_3.message })];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    router.post(enums_1.FSXAProxyRoutes.FETCH_PROPERTIES_ROUTE, function (req, res) { return __awaiter(_this, void 0, void 0, function () {
        var response, err_4;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    logger.info('Received POST on route', enums_1.FSXAProxyRoutes.FETCH_PROPERTIES_ROUTE);
                    logger.debug('POST request body', req.body);
                    if (!req.body || req.body.locale == null) {
                        logger.error(enums_1.FSXAProxyRoutes.FETCH_PROPERTIES_ROUTE, 'missing locale', req.body);
                        return [2 /*return*/, res.status(400).json({
                                error: ExpressRouterIntegrationErrors.MISSING_LOCALE,
                            })];
                    }
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, api.fetchProjectProperties({
                            locale: req.body.locale,
                            additionalParams: req.body.additionalParams,
                            resolve: req.body.resolver,
                            filterContext: req.body.filterContext,
                            normalized: (_a = req.body) === null || _a === void 0 ? void 0 : _a.normalized,
                        })];
                case 2:
                    response = _b.sent();
                    return [2 /*return*/, res.json(response)];
                case 3:
                    err_4 = _b.sent();
                    logger.error('was not able to fetch project properties', err_4.message);
                    //response object contains error and message properties for backwards compatibility
                    return [2 /*return*/, res
                            .status(err_4.statusCode)
                            .send({ message: err_4.message, error: err_4.message })];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    if (api.enableEventStream()) {
        router.get([routes_1.STREAM_CHANGE_EVENTS_ROUTE, enums_1.FSXAProxyRoutes.STREAM_CHANGE_EVENTS_ROUTE], (0, modules_1.eventStreamHandler)(api));
    }
    router.all('*', function (req, res) {
        logger.info('Requested unknown route', req.route);
        return res.json({
            error: ExpressRouterIntegrationErrors.UNKNOWN_ROUTE,
        });
    });
    return router;
}
exports.default = getExpressRouter;
var getMappedFilters = function (filters) {
    return (Array.isArray(filters)
        ? filters
        : filters
            ? [filters]
            : []);
};
exports.getMappedFilters = getMappedFilters;
//# sourceMappingURL=express.js.map